;#___________________________________________________________________________________________________
;****************************************************************************************************|
; Program Palitra (c) Sergei Steshin (Akyltist)                                                      |
;----------------------------------------------------------------------------------------------------|
;; compiler:     FASM 1.69.31                                                                        |
;; version:      0.3.0                                                                               |
;; last update:  08/11/2012                                                                          |
;; e-mail:       dr.steshin@gmail.com                                                                |
;.....................................................................................................
;; History:                                                                                          |
;; 0.1.0 -   .                                                                  |
;; 0.2.0 -    ,     .                     |
;;       -  ,   rgb      .   |
;;       -       (      ).            |
;;       -  .                                                                         |
;; 0.3.0 -      ( NEXT)                                  |
;;       -  ,      .                      |
;;       -        6  4 ( 256,   ).|
;;       -  .                                                                         |
;.....................................................................................................
;; All rights reserved.                                                                              |
;;                                                                                                   |
;; Redistribution and use in source and binary forms, with or without modification, are permitted    |
;; provided that the following conditions are met:                                                   |
;;       * Redistributions of source code must retain the above copyright notice, this list of       |
;;         conditions and the following disclaimer.                                                  |
;;       * Redistributions in binary form must reproduce the above copyright notice, this list of    |
;;         conditions and the following disclaimer in the documentation and/or other materials       |
;;         provided with the distribution.                                                           |
;;       * Neither the name of the <organization> nor the names of its contributors may be used to   |
;;         endorse or promote products derived from this software without specific prior written     |
;;         permission.                                                                               |
;;                                                                                                   |
;; THIS SOFTWARE IS PROVIDED BY Sergei Steshin ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,      |
;; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A        |
;; PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL <copyright holder> BE LIABLE FOR ANY DIRECT, |
;; INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED    |
;; TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS       |
;; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT          |
;; LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS  |
;; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                      |
;....................................................................................................|


;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                    |
;----------------------------------------------------------------------------------------------------/
  use32
  org	 0x0

  db	 'MENUET01'
  dd	 0x01
  dd	 START
  dd	 I_END
  dd	 0x1000
  dd	 0x1000
  dd	 0x0
  dd	 0x0

include '../../../macros.inc'


START:
;#___________________________________________________________________________________________________
;****************************************************************************************************|
;    -                                                          |
;----------------------------------------------------------------------------------------------------/
red:
    call draw_window                      ;    
still:
    mcall   10                            ;  10 -  
    cmp     eax,1                         ;   ?
    je      red                           ;   -   red
    cmp     eax,2                         ;   ?
    je      key                           ;   -  key
    cmp     eax,3                         ;   ?
    je      button                        ;   -  button
    jmp     still                         ;    -   
;end_still


key:                                      ;    
    mcall   2                             ;  2 -    ( ah) (    )
    jmp     still                         ;    
;end_key

button:
    mcall   17                            ; 17 -    
    cmp     ah, 1                         ;      1,
    jz      bexit                         ; 
  ;  Next
    cmp     ah, 11                        ;    NEXT
    jne     next_bg                       ; 
    inc     [pnext]                       ;     
    mov     eax,[pnext]
    cmp     al,6
    jne     next_redraw
    xor     eax,eax
    mov     [pnext],eax
  next_redraw:
    call    draw_palitra                  ;  
    ;call    draw_result                   ;  
    jmp     still

  next_bg:
    cmp     ah, 12                        ;    BACKGROUND
    jne     next_end                      ; 
	mcall   15,4,1
	mcall   15,1,1,1
	mcall   15,5,color,0,3*1*1
	mcall   15,3
	jne     next_redraw
  next_end:
    cmp     ah, 7
    jne     color_button
    call    mouse_get
    jmp     still
  color_button:
    push    eax
    call    mouse_local                   ;   
    mov     ebx,129
    mov     ecx,[mouse_y]
    sub     ebx,ecx
    mov     ecx,3
    imul    ecx,ebx
    
    ;push    ecx


    pop     eax
  red_button:
    cmp     ah, 8
    jne     green_button
    mov     [cred],cl
    call    set_spectr
    jmp     still
  green_button:
    cmp     ah, 9
    jne     blue_button
    mov     [cgreen],cl
    call    set_spectr
    jmp     still
  blue_button:
    cmp     ah, 10
    jne     still
    mov     [cblue],cl
    call    set_spectr
    jmp     still
  bexit:
    mcall -1                              ;   
;end_button

;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                      |
;----------------------------------------------------------------------------------------------------/
draw_window:
    mov     eax,12                        ;  12: ,    
    mov     ebx,1                         ; 1, 
    int     0x40                          ; 

    mov     eax,48                        ;  48 -   
    mov     ebx,3                         ;  3 -    .
    mov     ecx,sc                        ;     edx ,  
    mov     edx,sizeof.system_colors      ;    (  40 )
    int     0x40                          ; 

    mov     eax,48                        ;  48 -   .
    mov     ebx,4                         ;  4 -  eax =  .
    int     0x40                          ; 
    mov     ecx,eax                       ;   

    xor     eax,eax                       ;  eax (mov eax,0) ( 0)
    mov     ebx,200 shl 16+250            ; [   x]*65536 + [   x]
    add     ecx,200 shl 16+195            ;   + [  y]*65536 + [  y] (168   0.2)
    mov     edx,[sc.work]                 ;     
    or      edx,0x34000000                ;      
    mov     edi,title                     ;  
    int     0x40                          ; 

    call    draw_palitra                  ;  
    call    draw_result                   ;  

    mov     eax,8                         ;  8 - / 
    mov     ebx,89 shl 16+147             ;     [- x]*65536 + []
    mov     ecx,9 shl 16+147              ;    y [- y]*65536 + []
    mov     edx,0x60000007                ;  ID  - 0xXYnnnnnn
    int     0x40

    mov     ebx,9 shl 16+12               ;     [- x]*65536 + []
    mov     edx,0x60000008                ; ID = 8
    mov     ecx,45 shl 16+85              ;    y [- y]*65536 + []
    int     0x40                          ;      red
    add     ebx,26 shl 16                 ; 
    inc     edx                           ; ID = 9
    int     0x40                          ;      green
    add     ebx,26 shl 16                 ; 
    inc     edx                           ; ID = 10
    int     0x40                          ;      blue

    mov     eax,12                        ;  12: ,    
    mov     ebx,2                         ; 2 -  
    int     0x40                          ; 

    ;.................................................................................................
    ;   
    ;.................................................................................................
    mov     eax,8                         ;  8 - / 
    mov     ebx,4 shl 16+64               ;     [- x]*65536 + []
    mov     ecx,169 shl 16+16             ;    y [- y]*65536 + []
    mov     edx,11                        ; ID = 11
    mov     esi,[sc.work_button]          ; 
    int     0x40

    mov     ebx,80 shl 16+102             ;     [- x]*65536 + []
    mov     edx,12                        ; ID = 11
    int     0x40
	
	
    mov     eax,4                         ; 4 -     
    mov     ebx,25 shl 16+174             ; [   x]*65536 + [   y]
    mov     ecx,[sc.work_button_text]     ; 0xX0RRGGBB (RR, GG, BB   )
    mov     edx,bnext                     ;    
    ;mov     esi,1                        ;  esi 
    int     0x40

    ;mov     ebx,247 shl 16+64             ;     [- x]*65536 + []
    ;mov     edx,12                        ; ID = 12
    ;int     0x40

    mov     eax,38                        ;  38 -  .
    mov     ebx,4 shl 16+236              ;[    x]*65536 + [    x] 
    mov     ecx,163 shl 16+163            ;[    y]*65536 + [    y] 
    mov     edx,0x00666666                ;0x00RRGGBB -  
    int     0x40

    ret                                   ;  


;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                       |
;----------------------------------------------------------------------------------------------------/

mouse_global:
    ;.................................................................................................
    ;   
    ;.................................................................................................
    mov     eax,37                        ;  37 -   
    mov     ebx,0                         ;    
    int     0x40                          ; eax = x*65536 + y, (x,y)=  
    mov     ecx,eax                       ;
    shr     ecx,16                        ; ecx = x+1
    movzx   edx,ax                        ; edx = y+1
    dec     ecx                           ; ecx = x
    dec     edx                           ; edx = y
    mov     [mouse_x],ecx                 ; mouse_x = x
    mov     [mouse_y],edx                 ; mouse_y = y
    ret                                   ;  
;end_mouse_global

mouse_local:
    ;.................................................................................................
    ;     
    ;.................................................................................................
    mov     eax,37                        ;  37 -   
    mov     ebx,1                         ;    
    int     0x40                          ; eax = x*65536 + y, (x,y)=  
    mov     ecx,eax                       ;
    shr     ecx,16                        ; ecx = x+1
    movzx   edx,ax                        ; edx = y+1
    dec     ecx                           ; ecx = x
    dec     edx                           ; edx = y
    mov     [mouse_x],ecx                 ; mouse_x = x
    mov     [mouse_y],edx                 ; mouse_y = y
    ret                                   ;  
;end_mouse_local

desktop_get:
    ;.................................................................................................
    ;   
    ;.................................................................................................
    mov     eax,14                        ;    (eax = [xsize]*65536 + [ysize])
    int     0x40                          ; xsize =    - 1 
    mov     ebx,eax                       ;
    shr     ebx,16                        ; ebx = xsize-1
    ;movzx   edx,ax                       ;; edx = ysize-1 ( )
    inc     ebx                           ; ebx = xsize
    ;inc     edx                          ;; edx = ysize ( )
    mov     [desctop_w],ebx
    ret
;end_desktop_get

mouse_get:
    mov     esi,2                         ; :    
    call    mouse_global
    call    desktop_get
    re_mouse_loop:                        ; :       
      mov     ebx,[desctop_w]
      imul    ebx,[mouse_y]               ; ebx = y*xsize
      add     ebx,[mouse_x]               ; ebx = y*xsize+x

      ;.................................................................................................
      ;      
      ;.................................................................................................
      mov     eax,35                      ;   
      ;mov     ebx,ecx                    ;; ebx = y*xsize+x ( )
      int     0x40                        ;    eax
      cmp     eax,[sc.work]               ;    
      je      mouse_err                   ;    -    
      cmp     eax,0x222222                ;    
      je      mouse_err                   ;    -    
      jmp     mouse_set                   ; :      
    mouse_err:                            ; :      
      inc     [mouse_y]                   ; :      
      inc     [mouse_x]                   ; :      
      dec     esi                         ; :  
      cmp     esi,0                       ; :   
    jz        mouse_exit                  ; :       
    jmp    re_mouse_loop                  ; :        
    mouse_set:
    mov     [color],eax                   ;    
    call    draw_result                   ;  
    mouse_exit:
    ret                                   ;  
;end_mouse_get----------------------------------------------------------------------------------------

draw_palitra:
    ;.................................................................................................
    ;    
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,0x222222                  ; 
    mov     ecx,9 shl 16+73               ;    y [- y]*65536 + []
    mov     esi,2                         ;   
    re_draw:
    mov     ebx,89 shl 16+73              ;    x [- x]*65536 + []
    mov     edi,2                         ;   
    for_fon_loop:
      int     0x40                        ; 
      add     ebx,75 shl 16               ;     
      dec     edi                         ;   
      cmp     edi,0                       ;   
    jnz     for_fon_loop                  ;       
    dec     esi                           ;  
    cmp     esi,0                         ;   
    mov     ecx,84 shl 16+73              ;    y [- y]*65536 + []
    jnz     re_draw                       ;       

    ;.................................................................................................
    ;    
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,0x0FFFFFFF                ; 
    mov     esi,4                         ;    (#4,8)
    mov     ebx,78 shl 16+8               ;    x [- x]*65536 + []
    for_abz:
      ;;push    esi                       ;      
      cmp     esi,2
      jne     x2_line
      mov     ebx,78 shl 16+8
      x2_line:
      add     ebx,3 shl 16                ;     x
      mov     edi,8                       ;     
      for_stolbik:
        push    edi                       ;      
        mov     edi,8                     ;     
        mov     ecx,  1 shl 16+8          ;    y [- y]*65536 + []  
        cmp     esi,2
        jg      y2_line                   ;   4  
        mov     ecx,76 shl 16+8
        y2_line:
        add     ebx,9 shl 16              ;     x
        for_loop:
          add     ecx,9 shl 16            ;     y
          int     0x40                    ; 
          call    sub_red
          dec     edi                     ;   
          cmp     edi,0                   ;   
          jnz     for_loop                ;       
      call    sub_green
      pop     edi                         ;    
      dec     edi                         ;  
      cmp     edi,0                       ;   
      jnz     for_stolbik                 ;       
    call    sub_blue
    ;;pop     esi                         ;    
    dec     esi                           ;  
    cmp     esi,0                         ;   
    jnz     for_abz                       ;       
    ret                                   ;  
;end_draw_palitra-------------------------------------------------------------------------------------


sub_red:
    ;.................................................................................................
    ;        
    ;.................................................................................................
    push    eax
    mov     eax,[pnext]
  ;sub_red_0                              ; palitra
    cmp     al,0
    jne     sub_red_1
    sub     edx,0x20
    jmp     sub_red_e
  sub_red_1:                              ; random
    cmp     al,1
    jne     sub_red_2
    sub     edx,0x40
    jmp     sub_red_e
  sub_red_2:                              ; gree
    cmp     al,2
    jne     sub_red_3
    sub     edx,0x010101
    jmp     sub_red_e
  sub_red_3:                              ; red
    cmp     al,3
    jne     sub_red_4
    sub     edx,0x0101
    jmp     sub_red_e
  sub_red_4:                              ; green
    cmp     al,4
    jne     sub_red_5
    sub     edx,0x010001
    jmp     sub_red_e
  sub_red_5:                              ; blue
    cmp     al,5
    jne     sub_red_e
    sub     edx,0x010100
    jmp     sub_red_e
  sub_red_e:
    pop     eax
    ret                                   ;  
;end_sub_red------------------------------------------------------------------------------------------

sub_green:
    ;.................................................................................................
    ;        
    ;.................................................................................................
    push    eax
    mov     eax,[pnext]
  ;sub_green_0
    cmp     al,0
    jne     sub_green_1
    sub     edx,0x2000
    jmp     sub_green_e
  sub_green_1:
    cmp     al,1
    jne     sub_green_e
    sub     edx,0x4000
    ;jmp     sub_green_e
  sub_green_e:
    pop     eax
    ret                                   ;  
;end_sub_green----------------------------------------------------------------------------------------


sub_blue:
    ;.................................................................................................
    ;        
    ;.................................................................................................
    push    eax
    mov     eax,[pnext]
  ;sub_blue_0
    cmp     al,0
    jne     sub_blue_1
    sub     edx,0x400000
    jmp     sub_blue_e
  sub_blue_1:
    cmp     al,1
    jne     sub_blue_e
    sub     edx,0x600000
    ;jmp     sub_blue_e
  sub_blue_e:
    pop     eax
    ret                                   ;  
;end_sub_blue-----------------------------------------------------------------------------------------

draw_result:
    ;.................................................................................................
    ;     hex
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,0x222222                  ; -
    mov     ebx,4 shl 16+15               ;    x [- x]*65536 + []
    mov     ecx,9 shl 16+15               ;    y [- y]*65536 + []
    int     0x40                          ;  (  )
    mov     ebx,23 shl 16+62              ;    x [- x]*65536 + []
    int     0x40                          ;  (  )

    mov     edx,[color]                   ; 
    mov     ebx,5 shl 16+13               ;    x [- x]*65536 + []
    mov     ecx,10 shl 16+13              ;    y [- y]*65536 + []
    int     0x40                          ;  (  )
    mov     edx,0xFFFFFF                  ; -
    mov     ebx,24 shl 16+60              ;    x [- x]*65536 + []
    int     0x40                          ;  (  )

    mov     eax,47                        ;  47 -    
    mov     ecx,[color]                   ;  ( bl=0)   ( bl=1)
    mov     esi,0x0                       ; 0xX0RRGGBB
    mov     ebx,256+8 shl 16              ;      (HEX)
    mov     edx,34 shl 16+13              ; [   x]*65536 + [   y]
    int     0x40                          ;  -     (HEX)

    mov     eax,4                         ;  4:    
    mov	    ebx,27*65536+13               ; [x ] *65536 + [y ]
    mov	    ecx,0x0                       ;   RRGGBB
    mov	    edx,hex                       ;  '#'
    mov	    esi,1                         ;    
    int	    0x40

    ;.................................................................................................
    ;    r g b 
    ;.................................................................................................
    call    get_spectr
    mov     eax,13                        ;  13 -   Leency{
    mov     edx,0x222222                  ; -
    mov     ebx,4 shl 16+24               ;    x [- x]*65536 + []
    mov     ecx,142 shl 16+15             ;    y [- y]*65536 + []
    int     0x40 
    mov     ebx,33 shl 16+24              ;    x [- x]*65536 + []
    int     0x40 
    mov     ebx,62 shl 16+24              ;    x [- x]*65536 + []
    int     0x40 
    mov     edx,0xFFFFFF                  ; -
    mov     ebx,5 shl 16+22               ;    x [- x]*65536 + []
    mov     ecx,143 shl 16+13             ;    y [- y]*65536 + []
    int     0x40 
    mov     ebx,34 shl 16+22              ;    x [- x]*65536 + []
    int     0x40 
    mov     ebx,63 shl 16+22              ;    x [- x]*65536 + []
    int     0x40 

    ;.................................................................................................
    ;  r g b 
    ;.................................................................................................
    movzx   eax,[cred]                    ; 
    mov	    ebx,7*65536+146               ; [x ] *65536 + [y ]
    call    draw_value                    ;  

    movzx   eax,[cgreen]                  ; 
    mov	    ebx,36*65536+146              ; [x ] *65536 + [y ]
    call    draw_value                    ;  

    movzx   eax,[cblue]                   ; 
    mov	    ebx,65*65536+146              ; [x ] *65536 + [y ]
    call    draw_value                    ;  

    ;.................................................................................................
    ;  
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,[sc.work]                 ; -
    mov     ebx,8 shl 16+66               ;    x [- x]*65536 + []
    mov     ecx,40 shl 16+87              ;    y [- y]*65536 + []
    int     0x40

    ; mov     eax,13                        ;  13 -  
    ; mov     edx,0x222222                  ; -
    ; mov     ebx,4 shl 16+24               ;    x [- x]*65536 + []
    ; mov     ecx,30 shl 16+105             ;    y [- y]*65536 + []
    ; int     0x40
    ; add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    ; int     0x40
    ; add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    ; int     0x40

    mov     eax,13                        ;  13 -  
    mov     edx,[sc.work]                 ; -
    mov     ebx,5 shl 16+22               ;    x [- x]*65536 + []
    mov     ecx,31 shl 16+103             ;    y [- y]*65536 + []
    int     0x40
    add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    int     0x40
    add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    int     0x40

    ;.................................................................................................
    ;   r g b
    ;.................................................................................................
    mov     eax,4                         ; 4 -     
    mov     ebx,12 shl 16+34              ; [   x]*65536 + [   y]
    mov     ecx,0x0                       ; 0xX0RRGGBB (RR, GG, BB   )
    mov     edx,cname                     ;    
    mov     esi,1                         ;  esi 
    newline:                              ; 
      int     0x40                        ; 
      add     ebx,29 shl 16               ; 
      add     edx,1                       ; 
      cmp     [edx],byte 'x'              ;    
    jne    newline                        ;      

    ;.................................................................................................
    ;  
    ;.................................................................................................
    mov     eax,13                        ;  13 -  
    mov     edx,0x222222                  ; -
    mov     ebx,12 shl 16+4               ;    x [- x]*65536 + []
    mov     ecx,45 shl 16+85              ;    y [- y]*65536 + []
    int     0x40
    add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    int     0x40
    add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    int     0x40

    mov     edx,0xFA0919                  ; -
    mov     ebx,13 shl 16+2               ;    x [- x]*65536 + []
    mov     ecx,46 shl 16+83              ;    y [- y]*65536 + []
    int     0x40
    mov     edx,0x08CE19                  ; -
    add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    int     0x40
    mov     edx,0x0909FF                  ; -
    add     ebx,29 shl 16                 ;    x [- y]*65536 + []
    int     0x40

    ;.................................................................................................
    ;  
    ;.................................................................................................
    mov     edx,0x0                       ; -
    mov     ebx,10 shl 16+8               ;    x [- x]*65536 + []
    movzx   eax,[cred]                    ;   
    call    draw_slider
    add     ebx,29 shl 16
    movzx   eax,[cgreen]                  ;   
    call    draw_slider
    add     ebx,29 shl 16
    movzx   eax,[cblue]                   ;   
    call    draw_slider

    ret                                   ;  
;end_draw_result

draw_slider:
    xor     ecx,ecx
    mov     cl,0x3                        ;     3     85 
    div     cl                            ;  -   al   ah
    mov     cl,128                        ;   
    sub     cl,al                         ; cl=cl-al
    shl     ecx,16
    add     ecx,4                         ;   
    mov     eax,13                        ;  13 -  
    int     0x40
    ret                                   ;  

;end_slider

draw_value:
    ;.................................................................................................
    ;       
    ;.................................................................................................
    push    ebx                           ;   
    mov     ebx,10                        ;    
    mov     edi,buff                      ;    
    call    int2ascii                     ;         + esi 
    mov     eax,4                         ;  4:    
    pop     ebx                           ;     
    mov	    ecx,0x0                       ;   RRGGBB
    mov	    edx,buff                      ;    
    int	    0x40
    ret                                   ;  
;end_draw_value

hex_digit:
    ;.................................................................................................
    ;   ASCII (    )
    ;.................................................................................................
    cmp    dl,10                          ;  dl    0  15
    jb     .less                          ;  dl<10  
    add    dl,'A'-10                      ; 10->A 11->B 12->C ...
    ret                                   ;  
    .less:
    or     dl,'0'                         ;    10-  
    ret                                   ;  
;end_hex_digit

int2ascii:
    ;.................................................................................................
    ;    
    ;.................................................................................................
    ; eax - 32-  
    ; ebx -   
    ; edi -    
    ;     esi -  
    ;pushad
    xor     esi,esi                       ;   
    convert_loop:
    xor     edx,edx                       ;    
    div     ebx                           ; eax/ebx -   edx
    call    hex_digit                     ;  
    push    edx                           ;   
    inc     esi                           ;  
    test    eax,eax                       ;    
    jnz     convert_loop                  ;   
    cld                                   ;     DF ( )
    write_loop:                           ; 
    pop     eax                           ;     
    stosb                                 ;      ES:(E)DI
    dec     esi                           ;  
    test    esi,esi                       ;      
    jnz     write_loop                    ;  
    mov     byte [edi],0                  ;    
    ;popad                                 ;   
    ;        ,      
    mov	    edi,buff                      ;    
    call    str_len
    mov     esi,eax
    ret                                   ;   
;end_int2ascii

get_spectr:
    ;.................................................................................................
    ;  r,g,b  
    ;.................................................................................................
    ; get blue
    mov     ecx,[color]
    movzx   eax,cl
    mov     [cblue],al
    ; get red
    mov     eax,ecx
    xor     ax,ax
    shr     eax,16
    mov     [cred],al
    ; get green
    shl      ecx,16
    shr      ecx,24
    mov      [cgreen],cl
    ret                                   ;   
;end_get_spectr

set_spectr:
    ;.................................................................................................
    ;   r,g,b 
    ;.................................................................................................
    ; get blue
    movzx   eax,[cred]
    shl     eax,8
    mov     al,[cgreen]
    shl     eax,8
    mov     al,[cblue]
    mov     [color],eax
    call    draw_result                   ;  
    ret                                   ;   
;end_get_spectr

str_len:
    ;.................................................................................................
    ;    (->EDI ZS offset ; ->EAX ZS length)
    ;.................................................................................................
	push ecx
	push esi
	push edi

	cld
	xor   al, al
	mov ecx, 0FFFFFFFFh
	mov esi, edi
	repne scasb
	sub edi, esi
	mov eax, edi
	dec eax

	pop edi
	pop esi
	pop ecx

	ret
;end_str_len
;#___________________________________________________________________________________________________
;****************************************************************************************************|
;                                                                             |
;----------------------------------------------------------------------------------------------------/

    color       dd 00000000h              ;    
    mouse_x     dd 0                      ;     
    mouse_y     dd 0                      ;     
    desctop_w   dd 0                      ;   
    sc          system_colors             ;     
    title       db 'Palitra v0.3',0       ;   
    hex         db '#',0                  ;     
    cname       db 'RGBx'                 ;    (red,green,blue) x- 
    cred        db 0                      ;   
    cgreen      db 0                      ;   
    cblue       db 0                      ;   
    buff        db '000',0
    bnext       db 'NEXT         BACKGROUND',0;  
    pnext       dd 0                      ;   
I_END:


